<template>
	<view class="container">
		<!-- 每一个选项区域 -->
		<view class="box">
			<view class="name">
				规则名称：
			</view>
			<view class="val" @click="goPageRuleName">
				<view class="ele" v-if="ruleName=='未设置'">
					{{ruleName}}
				</view>
				<view class="ele black" v-else>
					{{ruleName}}
				</view>
				<view class="right">
					<img src="../../static/right.png">
				</view>
			</view>
		</view>

		<view class="box">
			<view class="name">
				考 勤 组：
			</view>
			<view class="val" @click="goPageGroup">
				<view class="ele" v-if="group=='未设置'">
					{{group}}
				</view>
				<view class="ele black" v-else>
					{{group}}
				</view>
				<view class="right">
					<img src="../../static/right.png">
				</view>
			</view>

		</view>

		<view class="box">
			<view class="name">
				打卡时间：
			</view>
			<view class="val" @click="goPagePunchTime">
				<view class="ele" v-if="time=='未设置'">
					{{time}}
				</view>
				<view class="ele black" v-else>
					<span>{{time.join("，")}}</span>
					<span v-for="(item,index) in periods" :key="index">
						{{item.beginTime}}-{{item.endTime}}
					</span>
				</view>
				<view class="right">
					<img src="../../static/right.png">
				</view>
			</view>
		</view>

		<view class="box">
			<view class="name">
				打卡地点：
			</view>
			<view class="val" @click="goPagePunchLocation">
				<view class="ele" v-if="place=='未设置'">
					{{place}}
				</view>
				<view class="ele black" v-else>
					{{place}}
				</view>
				<view class="right">
					<img src="../../static/right.png">
				</view>
			</view>
		</view>

		<view class="box">
			<view class="name">
				提前通知：
			</view>
			<picker :value="index" :range="array" @change="changeSelect">
				<view class="val">
					<view class="ele" v-if="value=='未设置'">
						{{value}}
					</view>
					<view class="ele black" v-else>
						{{value}}分钟
					</view>
					<view class="right">
						<img src="../../static/right.png">
					</view>
				</view>
			</picker>

		</view>


		<!-- 确认按钮区域 -->
		<view class="button" @click="handleConfirm">
			确认
		</view>

		<!-- 删除按钮区域 -->
		<view class="button2" @click="handleDelete">
			删除
		</view>

	</view>
</template>

<script>
	export default {
		data() {
			return {
				info: {},
				// 规则名称
				ruleName: "未设置",
				// 考勤组
				group: "未设置",
				// 打卡时间
				time: "未设置",
				// 打卡地点
				place: "未设置",
				// 提前通知
				value: "未设置",
				// 提前通知选项
				array: ['5分钟', '10分钟', '15分钟', '20分钟'],
				periods: [],
				index: 0,
				id: "",
				groupIds: [],
				timeGroups: []
			};
		},
		onLoad(option) {
			uni.removeStorageSync("chooseList_edit")
			uni.$on('updateRuleName', (data) => {
				this.ruleName = data
			})

			uni.$on('updateRuleGroup', (data) => {
				let temList = []
				data.forEach((ele) => {
					temList.push(
						ele.name
					)
				})
				this.group = temList.join("，")
			})

			this.info = JSON.parse(option.info)
			console.log(this.info);
			if (this.info) {
				this.ruleName = this.info.name
				this.group = this.info.groups
				this.place = this.info.locations
				this.value = this.info.noticeTime
				this.id = this.info.id

				this.time = this.info.temList

				this.periods = []
				this.info.periods.forEach((ele) => {
					this.periods.push({
						beginTime: this.format_time(ele.beginTime),
						endTime: this.format_time(ele.endTime)
					})
				})
			}
		},
		onShow() {
			let rulePlace = uni.getStorageSync("chooseList") || uni.getStorageSync("chooseList_edit")
			if (rulePlace) {
				let temList = []
				rulePlace.forEach((ele) => {
					temList.push(ele.name)
				})
				this.place = temList.join("，")
			}
			
			// let ruleTime = uni.getStorageSync("ruleTime_edit")
			// console.log(ruleTime);
			// if (ruleTime) {
			// 	this.time = ruleTime
			// 	let temList = []
			// 	ruleTime.forEach((ele) => {
			// 		temList.push({
			// 			dayOfWeeks: ele.selectedWeeks,
			// 			periods: ele.list
			// 		})
			// 	})
			// 	temList.forEach((item) => {
			// 		item.dayOfWeeks = item.dayOfWeeks.map((element) => {
			// 			if (element == '星期一') {
			// 				return element = 1
			// 			}
			// 			if (element == '星期二') {
			// 				return element = 2
			// 			}
			// 			if (element == '星期三') {
			// 				return element = 3
			// 			}
			// 			if (element == '星期四') {
			// 				return element = 4
			// 			}
			// 			if (element == '星期五') {
			// 				return element = 5
			// 			}
			// 			if (element == '星期六') {
			// 				return element = 6
			// 			}
			// 			if (element == '星期天') {
			// 				return element = 7
			// 			}
			// 		})
			// 	})
			// 	this.timeGroups = temList
			// }
			// 	let ruleName = uni.getStorageSync("ruleName")
			// 	if (ruleName) {
			// 		this.ruleName = ruleName
			// 	}

			// 	let ruleGroup = uni.getStorageSync("ruleGroup")
			// 	if (ruleGroup) {
			// 		let temList = []
			// 		this.groupIds = []
			// 		ruleGroup.forEach((ele) => {
			// 			temList.push(ele.name)
			// 			this.groupIds.push(ele.id)
			// 		})
			// 		this.group = temList.join("，")
			// 	}

				let ruleTime = uni.getStorageSync("ruleTime")
				let flag = uni.getStorageSync("flag")
				console.log(ruleTime);
				console.log(flag);
				if (ruleTime.length == 0 && flag) {
					this.time = "未设置"
				}
				if (ruleTime.length > 0) {
					this.time = ruleTime[0].selectedWeeks
					this.periods = ruleTime[0].list
					this.time = ruleTime
					let temList = []
					ruleTime.forEach((ele) => {
						temList.push({
							dayOfWeeks: ele.selectedWeeks,
							periods: ele.list
						})
					})
					temList.forEach((item) => {
						item.dayOfWeeks = item.dayOfWeeks.map((element) => {
							if (element == '星期一') {
								return element = 1
							}
							if (element == '星期二') {
								return element = 2
							}
							if (element == '星期三') {
								return element = 3
							}
							if (element == '星期四') {
								return element = 4
							}
							if (element == '星期五') {
								return element = 5
							}
							if (element == '星期六') {
								return element = 6
							}
							if (element == '星期天') {
								return element = 7
							}
						})
					})
					this.timeGroups = temList
				}
				console.log(this.periods);
				console.log(this.time);
		},
		methods: {
			// 点击确认按钮回调
			handleConfirm() {
				if (this.ruleName == '未设置') {
					uni.showToast({
						title: "请设置规则名称",
						icon: 'none'
					})
					return
				}

				if (this.group == '未设置') {
					uni.showToast({
						title: "请设置考勤组",
						icon: 'none'
					})
					return
				}

				if (this.time == '未设置') {
					uni.showToast({
						title: "请设置打卡时间",
						icon: 'none'
					})
					return
				}

				if (this.place == '未设置' || this.place == "") {
					uni.showToast({
						title: "请设置打卡地点",
						icon: 'none'
					})
					return
				}

				if (this.value == '未设置') {
					uni.showToast({
						title: "请设置提前通知时间",
						icon: 'none'
					})
					return
				}
				uni.showModal({
					title: '提示',
					content: '确定修改吗？',
					success: (res) => {
						if (res.confirm) {

							console.log('用户点击确定');

						} else if (res.cancel) {}
					}
				});
			},
			// 点击删除按钮回调
			handleDelete() {
				uni.showModal({
					title: '提示',
					content: '确定删除吗？',
					success: async (res) => {
						if (res.confirm) {
							let res = await this.$myRequest({
								url: "/attendance/api/settings/rule/delete",
								method: "delete",
								data: {
									ids: [this.id]
								}
							})
							// console.log(res);
							if (res.code == 200) {
								uni.showToast({
									title: "删除成功"
								})
								setTimeout(() => {
									uni.navigateBack({
										delta: 1
									})
								}, 1500)
							}
						} else if (res.cancel) {}
					}
				});
			},
			// 提前通知选择框点击回调
			changeSelect(e) {
				let index = e.detail.value
				this.value = this.array[index]
				let index2 = this.value.indexOf("分", 0)
				this.value = this.value.substring(0, index2);
			},
			// 点击规则名称跳转回调
			goPageRuleName() {
				uni.navigateTo({
					url: `/pages/ruleName/ruleName`
				})
			},
			// 点击考勤组跳转回调
			goPageGroup() {
				uni.navigateTo({
					url: `/pages/group/group?flag=2`
				})
			},
			// 点击打卡时间跳转回调
			goPagePunchTime() {
				if (this.time == "未设置") {
					let periods = []
					let time = []
					uni.navigateTo({
						url: `/pages/punchTime/punchTime?time=${time}&periods=${periods}&type=1`
					})
				} else {
					let periods = JSON.stringify(this.periods)
					let time = JSON.stringify(this.time)
					uni.navigateTo({
						url: `/pages/punchTime/punchTime?time=${time}&periods=${periods}&type=1`
					})
				}
			},
			// 点击打卡地点跳转回调
			goPagePunchLocation() {
				uni.navigateTo({
					url: `/pages/punchLocation/punchLocation?id=${this.id}&type=1`
				})
			},
			// 格式化时间
			format_time(timestamp) {
				//时间戳为10位需*1000，时间戳为13位的话不需乘1000
				var date = new Date(timestamp);
				var h = (date.getHours() < 10 ? '0' + date.getHours() : date.getHours()) + ':';
				var m = (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes());
				let strDate = h + m;
				return strDate;
			}
		}
	}
</script>

<style lang="scss" scoped>
	.container {
		height: 100vh;
		background-color: #fff;

		.box {
			display: flex;
			align-items: center;
			margin: 0 30rpx;
			width: 690rpx;
			height: 90rpx;
			font-size: 30rpx;
			border-bottom: 1rpx solid #CCCCCC;
			background-color: #fff;

			.name {
				flex: 1;
			}

			.val {
				flex: 3;
				display: flex;
				align-items: center;

				.ele {
					display: inline-block;
					width: 460rpx;
					text-align: end;
					color: #A6A6A6;
					overflow: hidden;
					white-space: nowrap;
					text-overflow: ellipsis;

					span {
						margin-right: 10rpx;
					}
				}

				.black {
					color: #000;
				}

				.right {
					margin-left: 20rpx;
					width: 40rpx;
					display: inline-flex;
					justify-content: center;
					align-items: center;

					img {
						width: 16rpx;
						height: 25rpx;
					}
				}
			}
		}

		.button {
			margin: auto;
			margin-top: 52rpx;
			width: 690rpx;
			height: 80rpx;
			line-height: 80rpx;
			text-align: center;
			font-size: 32rpx;
			font-weight: 500;
			color: #fff;
			border-radius: 16rpx;
			background-color: #3396FB;
		}

		.button2 {
			margin: auto;
			margin-top: 30rpx;
			width: 690rpx;
			height: 80rpx;
			line-height: 80rpx;
			text-align: center;
			font-size: 32rpx;
			font-weight: 500;
			color: #FF5733;
			border-radius: 16rpx;
			background-color: #fff;
		}
	}
</style>
